.nolist
include \masm32\include\masm32rt.inc
.686
.xmm
include \masm32\macros\timers.asm

;	Usage:
;	timings InString, 1, addr MainString, addr SubString
;	timings DemoFastCall, ecx:82, edx:offset MainString, addr SubString	; the FASTCALL variant

timings MACRO algo, a1, a2, a3, a4, a5, a6
LOCAL tmp$, out$, Description, fc1, fc2, fcstr1, fcstr2, fls1, frs1, fls2, frs2
  fcstr1 equ <>
  fcstr2 equ <>
  ifndef LOOP_COUNT
	LOOP_COUNT = 1000000	;; default: one Million
  endif
  ifndef CurAlgo
  	CurAlgo equ <>
  endif
  ifdif CurAlgo, <algo>
  	CurAlgo equ <algo>
  endif

  Description equ <CurAlgo>

  tmp$ CATSTR <invoke >, <algo>
  ifnb <a1>
	fc1 INSTR <a1>, <:>
	if fc1 eq 4
		fls1 SUBSTR <a1>, 1, 3
		frs1 SUBSTR <a1>, 5
		fcstr1 CATSTR <mov >, <fls1>, <, >, <frs1>
	else
		tmp$ CATSTR tmp$, <, >, <a1>
	endif
	Description CATSTR Description, <, >, <a1>

  ifnb <a2>
	fc2 INSTR <a2>, <:>
	if fc2 eq 4
		fls2 SUBSTR <a2>, 1, 3
		frs2 SUBSTR <a2>, 5
		fcstr2 CATSTR <mov >, <fls2>, <, >, <frs2>
	else
		tmp$ CATSTR tmp$, <, >, <a2>
	endif
	Description CATSTR Description, <, >, <a2>
  ifnb <a3>
	tmp$ CATSTR tmp$, <, >, <a3>
	Description CATSTR Description, <, >, <a3>
  ifnb <a4>
	tmp$ CATSTR tmp$, <, >, <a4>
	Description CATSTR Description, <, >, <a4>
  ifnb <a5>
	tmp$ CATSTR tmp$, <, >, <a5>
	Description CATSTR Description, <, >, <a5>
  endif
  endif
  endif
  endif
  endif
  	echo bbbbbbbbbb
	% echo a=fcstr1
	% echo b=fcstr2
  ifndef globcycles		;; we might need to calculate a global average count
  	.data?
  	globcycles	dd ?
  	globcount	dd ?
  	.code
  endif
  ifndef REP_CT
	REP_CT = 1
  endif
  ifndef REP_CTold
	REP_CTold = REP_CT
  endif
  if REP_CT gt 1
  	if REP_CTold eq 1
  		pushad
		print chr$(13, 10)
		popad
	endif
	REP_CTold = REP_CT
  endif
  ;% echo tmp$			;; uncomment to see what exactly you are invoking
  REPEAT REP_CT
	invoke Sleep, 50
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		fcstr1
		fcstr2
		tmp$
	counter_end
	add globcycles, eax
	inc globcount
	out$ CATSTR <print str$(eax), 9, ">, Description, <", 13, 10>
	out$
  ENDM
  if REP_CT gt 1
	print chr$(13, 10)
  endif
ENDM

.code
MainString	db "This is a long string meant for testing the Masm32 lib InString algo, and we want to find the word 'end'", 0
SubString	db "end", 0

DemoFastCall proc arg3:DWORD
	invoke InString, ecx, edx, arg3
	ret
DemoFastCall endp

start:
	timings DemoFastCall, ecx:82, edx:offset MainString, addr SubString

	invoke Sleep, 50
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS				; --------- the traditional way ---------
		invoke InString, 1, addr MainString, addr SubString
	counter_end
	print str$(eax), 9, "InString, 1, addr MainString, addr SubString", 13, 10, 10	; --------- end traditional way ---------

	REP_CT = 5						; optional: perform the timings for five lines, to see the variance
	timings InString, 1, addr MainString, addr SubString		; --------- with the timings macro: one line ---------

	print chr$("Average cycle count:" , 9)
	mov eax, globcycles
	cdq
	div globcount
	print str$(eax), 13, 10, 10
	

	inkey "--- ok ---"
	exit

end start

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0
